#include<stdio.h>
#include<stdlib.h>

#define INF (-1)
#define TRUE 1
#define FALSE 0

int **graf, *rastojanja;
int *flag, N, M, P, Q, *prethodnici;

void stampajGraf()
{
	int i,j;
	
	for(i = 0; i < N; i++)
	{
		for(j = 0; j < N; j++)
		{
			printf("%3d ", graf[i][j]);
		}
		printf("\n");
	}
}

int jeManji(double x, double y)
{
	if(x == INF)
		return FALSE;
	if(y == INF)
		return TRUE;
		
	return (x < y);
}

int dajNajboljeg()
{
	double min = INF;
	int i, cvor = -1;
	
	for(i = 0; i < N; i++)
		if(flag[i] == FALSE && jeManji(rastojanja[i], min))
		{
			min = rastojanja[i];
			cvor = i;
		}
		
	return cvor;
}

main()
{
	
	int i, j;
	
	scanf("%d%d", &N, &M);
	
	graf = (int **) malloc(N * sizeof(int*));
	flag = (int *) malloc(N * sizeof(int));
	prethodnici = (int *) malloc(N * sizeof(int));
	rastojanja = (int *) malloc(N * sizeof(int));
	
	for(i = 0; i < N; i++)
	{
		graf[i] = (int *) malloc(N * sizeof(int));
		flag[i] = FALSE;
		prethodnici[i] = INF;
		rastojanja[i] = INF;
	}
	
	for(i = 0; i < N; i++)
		for(j = 0; j < N; j++)
		{
			graf[i][j] = INF;
		}
	
	int u, v, l;
		
	for(i = 0; i < M; i++)
	{
		scanf("%d%d%d", &u, &v, &l);
		
		graf[u - 1][v - 1] = graf[v - 1][u - 1] = l;
	}
	
	scanf("%d%d", &P, &Q);
	
	for(i = 0; i < N; i++)
		for(j = 0; j < N; j++)
			if(graf[i][j] != INF)
			{
				if(graf[i][j] < P)
					graf[i][j] = 0;
				else
				{
					int ostatak = 0;
					ostatak = graf[i][j] % P;
					
					if( ostatak == 0 )
						graf[i][j] = graf[i][j] / P * Q - Q;
					else
						graf[i][j] = graf[i][j] / P * Q;
				}
			}
	
	rastojanja[0] = 0;
	
	int brojVojnika = 0;
	
	while((v = dajNajboljeg()) != -1)
	{
		flag[v] = TRUE;
		
		for(j = 0; j < N; j++)
			if(graf[v][j] != INF && flag[j] == FALSE && jeManji(graf[v][j], rastojanja[j]))
			{
				rastojanja[j] = graf[v][j];
				prethodnici[j] = v;
			}
	}
	
	for(i = 0; i < N; i++)
	{
		brojVojnika += rastojanja[i];
	}
	
	printf("%d \n", brojVojnika);
}




